VERSION 5.00
Begin VB.UserControl Rejilla 
   ClientHeight    =   495
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1335
   PropertyPages   =   "Rejilla.ctx":0000
   ScaleHeight     =   495
   ScaleWidth      =   1335
   ToolboxBitmap   =   "Rejilla.ctx":0020
   Begin VB.PictureBox picRejilla 
      AutoRedraw      =   -1  'True
      FillStyle       =   0  'Solid
      Height          =   495
      Left            =   0
      ScaleHeight     =   29
      ScaleMode       =   3  'Pxel
      ScaleWidth      =   85
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Width           =   1335
   End
End
Attribute VB_Name = "Rejilla"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Constantes que expresan los minimos y maximos del tablero
Private Const lngMinColumnas As Long = 2
Private Const lngMinFilas As Long = 2
Private Const lngMaxColumnas As Long = 25
Private Const lngMaxFilas As Long = 25

'Variables que almacenan los colores del control
'Privadas para que el usuario del control no acceda
'a las variables sino a las propiedades.
Private rgbFondo As Long
Private rgbFrente As Long
Private rgbRejilla As Long

'Variables que almacenan las dimensiones(num de columnas y num de filas) en casillas del tablero
'Privadas para que el usuario del control no acceda
'a las variables sino a las propiedades.
Private lngColumnas As Long
Private lngFilas As Long
Private lngAnchoCasilla As Long
Private lngAltoCasilla As Long

'Este control va a lanzar 3 eventos de ratn
Event MouseDown(Button As Integer, Shift As Integer, X As Long, Y As Long)
Event MouseMove(Button As Integer, Shift As Integer, X As Long, Y As Long)
Event MouseUp(Button As Integer, Shift As Integer, X As Long, Y As Long)

'Las propiedades de lectura solo devuelven los valores de variables o constantes privadas
'El tipo OLE_COLOR sirve para poder ver el color y no su numero correspondiente
Property Get Fondo() As OLE_COLOR
    
    Fondo = rgbFondo
    
End Property
'En general, las propiedades de escritura suelen hacer comprobaciones
'previas,para comprobar los valores introducidos. Una vez comprobado
'se hacen los cambios derivados.
'Los argumentos en una propiedad de escritura se pasan por valor.
'Por defecto VB siempre pasa los argumentos por referencia ByRef
Property Let Fondo(ByVal rgbColor As OLE_COLOR)

    rgbFondo = rgbColor
    picRejilla.BackColor = rgbFondo
    'Hay que llamar a Dibujar tras cambiar propiedades de color
    Dibujar
    'El mtodo PropertyChanged sirve para avisar a VB de que una
    'propiedad ha cambiado su valor
    PropertyChanged "Fondo"

End Property
Property Get Frente() As OLE_COLOR

    Frente = rgbFrente

End Property
Property Let Frente(ByVal rgbColor As OLE_COLOR)

    rgbFrente = rgbColor
    picRejilla.ForeColor = rgbFrente
    'Hay que llamar a Dibujar tras cambiar propiedades de color
    Dibujar
    PropertyChanged "Frente"

End Property
Property Get Rejilla() As OLE_COLOR

    Rejilla = rgbRejilla

End Property
Property Let Rejilla(ByVal rgbColor As OLE_COLOR)

    rgbRejilla = rgbColor
    'Hay que llamar a Dibujar tras cambiar propiedades de color
    Dibujar
    PropertyChanged "Rejilla"
    
End Property
Property Get Columnas() As Long

    Columnas = lngColumnas

End Property
Property Let Columnas(ByVal lngNuevo As Long)

    On Error GoTo Error
    If (lngNuevo < lngMinColumnas Or lngNuevo > lngMaxColumnas) Then
        
        'genera un error cuando escribimos un valor
        'que esta fuera de los valores min y max
        Err.Raise (vbObjectError)
    End If
    lngColumnas = lngNuevo
    Borrar
    PropertyChanged "Columnas"
    Exit Property
    
Error:
    Dim strMensaje As String
    strMensaje = "La propiedad de Columnas de la rejila debe" & _
               vbCrLf & "tomar valores enteros entre " & lngMinColumnas & _
               vbCrLf & " y " & lngMaxColumnas & "."
    Call MsgBox(strMensaje, vbOKOnly & vbExclamation, "Rejilla")
    
End Property
Property Get Filas() As Long

    Filas = lngFilas

End Property
Property Let Filas(ByVal lngNuevo As Long)

    On Error GoTo Error
    If (lngNuevo < lngMinFilas Or lngNuevo > lngMaxFilas) Then
        
        'genera un error cuando escribimos un valor
        'que esta fuera de los valores min y max
        Err.Raise (vbObjectError)
    End If
    lngFilas = lngNuevo
    Borrar
    PropertyChanged "Filas"
    Exit Property
    
Error:
    Dim strMensaje As String
    strMensaje = "La propiedad de Filas de la rejila debe" & _
               vbCrLf & "tomar valores enteros entre " & lngMinFilas & _
               vbCrLf & " y " & lngMaxFilas & "."
    Call MsgBox(strMensaje, vbOKOnly & vbExclamation, "Rejilla")
    
End Property
Property Get Color(ByVal Columna As Long, ByVal Fila As Long) As Long
'Private Function ColorLeer(ByVal Columna As Long, ByVal Fila As Long) As Long
If (Columna < 1 Or Columna > lngColumnas Or Fila < 1 Or Fila > lngFilas) Then
    
    Exit Property
End If
'El METODO Point devuelve el color del punto
'del Picture especificado con las coordenadas (X,Y)
Color = picRejilla.Point((Columna - 1) * (lngAnchoCasilla + 1), _
                        (Fila - 1) * (lngAltoCasilla + 1))
                        
End Property
'Rellena con el color rgbColor en la casilla X,Y
Property Let Color(ByVal Columna As Long, ByVal Fila As Long, ByVal rgbColor As Long)
'Private Sub ColorEscr(ByVal Columna As Long, ByVal Fila As Long, ByVal rgbColor As Long)
If (Columna < 1 Or Columna > lngColumnas Or Fila < 1 Or Fila > lngFilas) Then
    
    Exit Property
End If
'Dibuja lneas o rectngulos en el objeto picRejilla.
'Step significa posicion del punto final relativa a la posicion
'del punto inicial.
'B significa que con los puntos inicial y  final se dibuja
'un rectangulo y F que se rellena
picRejilla.Line ((Columna - 1) * (lngAnchoCasilla + 1), _
                (Fila - 1) * (lngAltoCasilla + 1)) _
                -Step(lngAnchoCasilla - 1, lngAltoCasilla - 1), rgbColor, BF
                        
End Property
'Lee si el control esta habilitado para lanzar eventos
Property Get Enabled() As Boolean

    Enabled = UserControl.Enabled

End Property
'Escribe en la propiedad que habilita y deshabilita
'el control para lanzar eventos
Property Let Enabled(ByVal blnNuevo As Boolean)

    UserControl.Enabled = blnNuevo
    PropertyChanged "Enabled"

End Property
Property Get MinColumnas() As Long

    MinColumnas = lngMinColumnas
    
End Property
Property Get MinFilas() As Long

    MinFilas = lngMinFilas
    
End Property
Property Get MaxColumnas() As Long

    MaxColumnas = lngMaxColumnas
    
End Property
Property Get MaxFilas() As Long

    MaxFilas = lngMaxFilas
    
End Property
'Procedimiento que dibuja las rayas del control
Private Sub Dibujar()

    With picRejilla
        'El control picRejilla se escala a todo el
        'diseador del control
        .Height = ScaleHeight
        .Width = ScaleWidth
        
        Dim lngBorderHeight As Long
        Dim lngBorderWidth As Long
        
        'altura y anchura del borde con el cambio de escala de twips a pixels
        lngBorderHeight = .ScaleY(.Height, vbTwips, vbPixels) - .ScaleHeight
        lngBorderWidth = .ScaleX(.Width, vbTwips, vbPixels) - .ScaleWidth
        
        Dim lng As Long
        
        'A la anchura resultante de la division le resta 1
        'anchura interior del objeto picture
        lngAnchoCasilla = .ScaleWidth / lngColumnas - 1
        lng = lngAnchoCasilla * lngColumnas + 1 * (lngColumnas - 1) + lngBorderWidth
        'anchura total del objeto picture
        .Width = .ScaleX(lng, vbPixels, vbTwips)

        lngAltoCasilla = .ScaleHeight / lngFilas - 1
        lng = lngAltoCasilla * lngFilas + 1 * (lngFilas - 1) + lngBorderHeight
        .Height = .ScaleY(lng, vbPixels, vbTwips)
        
        'se ponen la altura y anchura del diseador de control
        'a los mismos valores que el control picRejilla
        Width = .Width
        Height = .Height
    
    End With
    
    Dim i As Long
    
    lng = 0
    
    For i = 1 To lngColumnas - 1
    
        lng = lng + lngAnchoCasilla
        
        'dibuja lineas en el objeto
        picRejilla.Line (lng, 0)-(lng, picRejilla.ScaleHeight), rgbRejilla
        
        lng = lng + 1
    Next i
    
    lng = 0
    
    For i = 1 To lngFilas - 1
    
        lng = lng + lngAltoCasilla
        
        'dibuja lineas en el objeto
        picRejilla.Line (0, lng)-(picRejilla.ScaleWidth, lng), rgbRejilla
        
        lng = lng + 1
    Next i
End Sub
'Se utiliza este evento para inicializar los valores de
'las propiedades
Private Sub UserControl_Initialize()

    rgbFondo = vbWhite
    rgbFrente = vbBlue
    rgbRejilla = vbBlack
    picRejilla.BackColor = rgbFondo
    picRejilla.ForeColor = rgbFrente
    lngFilas = 3
    lngColumnas = 3

End Sub
'Cuando se lanza el evento de Resize del control, hay que borrar
'y volver a dibujar el control
Private Sub UserControl_Resize()
    
    Borrar

End Sub
'Estos 2 eventos sirven para guardar y recuperar respectivamente
'los valores de las propiedades que aadamos a los controles
'junto con el formulario en el que se encuentre.
'Ambos reciben las propiedades almacenadas en PropertyBag.
'El evento WriteProperties se lanza cuando se guarda el formulario.
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        .WriteProperty "Fondo", rgbFondo
        .WriteProperty "Frente", rgbFrente
        .WriteProperty "Rejilla", rgbRejilla
        .WriteProperty "Columnas", lngColumnas
        .WriteProperty "Filas", lngFilas
        .WriteProperty "Enabled", Enabled
    End With
End Sub
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    With PropBag
        Fondo = .ReadProperty("Fondo", rgbFondo)
        Frente = .ReadProperty("Frente", rgbFrente)
        Rejilla = .ReadProperty("Rejilla", rgbRejilla)
        Columnas = .ReadProperty("Columnas", lngColumnas)
        Filas = .ReadProperty("Filas", lngFilas)
        Enabled = .ReadProperty("Enabled", Enabled)
    End With
End Sub
'Lanza el evento de MouseDown sobre el control ActiveX
Private Sub picRejilla_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim lngX As Long, lngY As Long
    
    If picRejilla.Point(X, Y) = rgbRejilla Then
        Exit Sub
    End If
    'El operador \ es una division que obtiene un resultado entero
    lngX = X \ (lngAnchoCasilla + 1) + 1
    lngY = Y \ (lngAltoCasilla + 1) + 1
    
    If (lngX < 1 Or lngX > lngColumnas Or lngY < 1 Or lngY > lngFilas) Then
        Exit Sub
    End If
    RaiseEvent MouseDown(Button, Shift, lngX, lngY)
    
End Sub
'Lanza el evento de MouseUp sobre el control ActiveX
Private Sub picRejilla_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim lngX As Long, lngY As Long
    
    If picRejilla.Point(X, Y) = rgbRejilla Then
        Exit Sub
    End If
    lngX = X \ (lngAnchoCasilla + 1) + 1
    lngY = Y \ (lngAltoCasilla + 1) + 1
    
    If (lngX < 1 Or lngX > lngColumnas Or lngY < 1 Or lngY > lngFilas) Then
        Exit Sub
    End If
    RaiseEvent MouseUp(Button, Shift, lngX, lngY)
    
End Sub
'Lanza el evento de MouseMove sobre el control ActiveX
Private Sub picRejilla_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim lngX As Long, lngY As Long
    
    If picRejilla.Point(X, Y) = rgbRejilla Then
        Exit Sub
    End If
    lngX = X \ (lngAnchoCasilla + 1) + 1
    lngY = Y \ (lngAltoCasilla + 1) + 1
    
    If (lngX < 1 Or lngX > lngColumnas Or lngY < 1 Or lngY > lngFilas) Then
        Exit Sub
    End If
    RaiseEvent MouseMove(Button, Shift, lngX, lngY)
    
End Sub
'Este mtodo se va a ejecutar con la propiedad Acerca de del
'control. Para ello selecionamos Herramientas->Atributos del Proc
Public Sub AcercaDe()
Attribute AcercaDe.VB_UserMemId = -552
    Call MsgBox("Control ActiveX Rejilla - " & _
                "Programado por nosotros", _
                vbOKOnly Or vbInformation, _
                "Acerca del control ActiveX Rejilla")
End Sub
Public Sub Borrar()
    
    picRejilla.Cls
    Dibujar
    
End Sub
'Procedimiento para activar una casilla con el color de Frente
Public Sub Activar(Columna As Long, Fila As Long)

    Color(Columna, Fila) = rgbFrente
    'ColorEscr Columna, Fila, rgbFrente

End Sub
'Procedimiento para desactivar una casilla,es decir, ponerle el color de Fondo
Public Sub Desactivar(Columna As Long, Fila As Long)

    Color(Columna, Fila) = rgbFondo
    'ColorEscr Columna, Fila, rgbFondo

End Sub




