Attribute VB_Name = "Module1"
Option Explicit

Sub CrearBaseDeDatos()

'rutina de tratamiento de errores
On Error GoTo Error

Dim str As String   'cadena
Dim db  As Database 'base de datos
Dim tdb As TableDef 'tabla
Dim fld As Field    'campo
Dim idx As Index    'indice
Dim rel As Relation 'relacion

'str contendr la ruta de acceso a la BD que vamos a crear.
'Esta ruta va a estar en el directorio desde el que vamos
'a ejecutar el programa. Recordemos que si nos encontramos
'en el directorio raz, App.Path terminar en \, lo que no
'ocurrir en caso contrario. Tras conseguir, sea como sea,
'que al final de str haya un \, aadimos a la ruta el nombre
'de la BD, Editoria.mdb

str = App.Path
If Right(str, 1) <> "\" Then
    str = str & "\"
End If
str = str & "Editoria.mdb"

'creamos la BD, ubicada en str y con el idioma de la mquina
Set db = CreateDatabase(str, dbLangGeneral)

'creamos la tabla Libros
Set tdb = db.CreateTableDef("Libros")

'creamos un campo para la tabla
Set fld = tdb.CreateField("Titulo", dbText)
'aadimos este campo a la tabla
tdb.Fields.Append fld

'creamos un campo para la tabla
Set fld = tdb.CreateField("Autor", dbText)
'aadimos este campo a la tabla
tdb.Fields.Append fld

'creamos un campo para la tabla
Set fld = tdb.CreateField("NIFeditorial", dbText)
'aadimos este campo a la tabla
tdb.Fields.Append fld

'creamos la clave primaria de la tabla. Para ello hay que
'crear un ndice y luego decirle que es clave primaria
Set idx = tdb.CreateIndex("Titulo")
idx.Primary = True
idx.Unique = True

'creamos un campo para ese indice
Set fld = idx.CreateField("Titulo")
'aadimos este campo al indice
idx.Fields.Append fld

'aadimos este indice a la tabla
tdb.Indexes.Append idx

'aadimos la tabla a la BD
db.TableDefs.Append tdb

'creamos la tabla Editorial
Set tdb = db.CreateTableDef("Editorial")

'creamos un campo para la tabla
Set fld = tdb.CreateField("Nombre", dbText)
'aadimos este campo a la tabla
tdb.Fields.Append fld

'creamos un campo para la tabla
Set fld = tdb.CreateField("NIF", dbText)
'aadimos este campo a la tabla
tdb.Fields.Append fld

'creamos un campo para la tabla
Set fld = tdb.CreateField("N_empleados", dbInteger)
'aadimos este campo a la tabla
tdb.Fields.Append fld

'creamos la clave primaria de la tabla. Para ello hay que
'crear un ndice y luego decirle que es clave primaria
Set idx = tdb.CreateIndex("NIF")
idx.Primary = True
idx.Unique = True

'creamos un campo para ese indice
Set fld = idx.CreateField("NIF")
'aadimos este campo al indice
idx.Fields.Append fld

'aadimos este indice a la tabla
tdb.Indexes.Append idx

'aadimos la tabla a la BD
db.TableDefs.Append tdb

'creamos la tabla Empleados
Set tdb = db.CreateTableDef("Empleados")

'creamos un campo para la tabla
Set fld = tdb.CreateField("DNI", dbText)
'aadimos este campo a la tabla
tdb.Fields.Append fld

'creamos un campo para la tabla
Set fld = tdb.CreateField("Nombre", dbText)
'aadimos este campo a la tabla
tdb.Fields.Append fld

'creamos un campo para la tabla
Set fld = tdb.CreateField("Direccion", dbText)
'aadimos este campo a la tabla
tdb.Fields.Append fld

'creamos un campo para la tabla
Set fld = tdb.CreateField("NIF_empresa", dbText)
'aadimos este campo a la tabla
tdb.Fields.Append fld

'creamos la clave primaria de la tabla. Para ello hay que
'crear un ndice y luego decirle que es clave primaria
Set idx = tdb.CreateIndex("DNI")
idx.Primary = True
idx.Unique = True

'creamos un campo para ese indice
Set fld = idx.CreateField("DNI")
'aadimos este campo al indice
idx.Fields.Append fld

'aadimos este indice a la tabla
tdb.Indexes.Append idx

'aadimos la tabla a la BD
db.TableDefs.Append tdb

'creamos la relacion que une ambas tablas
Set rel = db.CreateRelation("Relacion1")
'indicamos la tabla origen
rel.Table = "Editorial"
'y la destino
rel.ForeignTable = "Libros"
'indicamos el campo de la tabla origen
Set fld = rel.CreateField("NIF")
'y en de la tabla destino
fld.ForeignName = "NIFeditorial"
'aadimos este campo a la relacion
rel.Fields.Append fld
'y la relacion a la BD
db.Relations.Append rel

'creamos la relacion que une ambas tablas
Set rel = db.CreateRelation("Relacion2")
'indicamos la tabla origen
rel.Table = "Editorial"
'y la destino
rel.ForeignTable = "Empleados"
'indicamos el campo de la tabla origen
Set fld = rel.CreateField("NIF")
'y en de la tabla destino
fld.ForeignName = "NIF_empresa"
'aadimos este campo a la relacion
rel.Fields.Append fld
'y la relacion a la BD
db.Relations.Append rel

'damos un mensaje de informacion
str = "La base de datos Editoria se ha creado con xito."
str = str & "Su ruta de acceso es :" & vbCrLf & db.Name

Call MsgBox(str, vbOKOnly Or vbInformation, "Atencin")


Exit Sub

Error:
'mostramos el nmero y descripcion del error
str = "Ha ocurrido el error nmero " & Err.Number & "." & vbCrLf
str = str & Err.Description

Call MsgBox(str, vbOKOnly Or vbCritical, "Atencin")

End Sub

Sub Main()

CrearBaseDeDatos

End Sub

